Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkRibbonFilter Class Reference

`#include <vtkRibbonFilter.h>`

Inheritance diagram for vtkRibbonFilter:

[legend]
Collaboration diagram for vtkRibbonFilter:

[legend]
List of all members.

## Detailed Description

create oriented ribbons from lines defined in polygonal dataset

Date:
  2003/01/09 19:21:05

Revision:
  1.43

vtkRibbonFilter is a filter to create oriented ribbons from lines defined in polygonal dataset. The orientation of the ribbon is along the line segments and perpendicular to "projected" line normals. Projected line normals are the original line normals projected to be perpendicular to the local line segment. An offset angle can be specified to rotate the ribbon with respect to the normal.

Warning:
  The input line must not have duplicate points, or normals at points that are parallel to the incoming/outgoing line segments. (Duplicate points can be removed with vtkCleanPolyData.) If a line does not meet this criteria, then that line is not tubed.

See also:
  vtkTubeFilter

Created by:
  - Schroeder, Will

CVS contributions (if > 5%):
  - Schroeder, Will (72%)
  - Martin, Ken (7%)
  - Geveci, Berk (5%)
  - Law, Charles (5%)

CVS logs (CVSweb):
  - .`h` (`/Graphics/vtkRibbonFilter.h)`
  - .`cxx` (`/Graphics/vtkRibbonFilter.cxx)`

Examples:
  vtkRibbonFilter (Examples)

Tests:
  vtkRibbonFilter (Tests)

Definition at line 75 of file vtkRibbonFilter.h.

## Public Types
typedef vtkPolyDataToPolyDataFilter | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
virtual void | SetWidth (float)
virtual float | GetWidth ()
virtual void | SetAngle (float)
virtual float | GetAngle ()
virtual void | SetVaryWidth (int)
virtual int | GetVaryWidth ()
virtual void | VaryWidthOn ()
virtual void | VaryWidthOff ()
virtual void | SetWidthFactor (float)
virtual float | GetWidthFactor ()
virtual void | SetDefaultNormal (float, float, float)
virtual void | SetDefaultNormal (float[3])
virtual float * | GetDefaultNormal ()
virtual void | GetDefaultNormal (float data[3])
virtual void | SetUseDefaultNormal (int)
virtual int | GetUseDefaultNormal ()
virtual void | UseDefaultNormalOn ()
virtual void | UseDefaultNormalOff ()
virtual void | SetGenerateTCoords (int)
virtual int | GetGenerateTCoords ()
void | SetGenerateTCoordsToOff ()
void | SetGenerateTCoordsToNormalizedLength ()
void | SetGenerateTCoordsToUseLength ()
void | SetGenerateTCoordsToUseScalars ()
const char * | GetGenerateTCoordsAsString ()
virtual void | SetTextureLength (float)
virtual float | GetTextureLength ()
## Static Public Methods
int | IsTypeOf (const char *type)
vtkRibbonFilter * | SafeDownCast (vtkObject *o)
vtkRibbonFilter * | New ()
## Protected Methods
| vtkRibbonFilter ()
| ~vtkRibbonFilter ()
void | Execute ()
int | GeneratePoints (vtkIdType offset, vtkIdType npts, vtkIdType *pts, vtkPoints *inPts, vtkPoints *newPts, vtkPointData *pd, vtkPointData *outPD, vtkFloatArray *newNormals, vtkDataArray *inScalars, float range[2], vtkDataArray *inNormals)
void | GenerateStrip (vtkIdType offset, vtkIdType npts, vtkIdType *pts, vtkIdType inCellId, vtkCellData *cd, vtkCellData *outCD, vtkCellArray *newStrips)
void | GenerateTextureCoords (vtkIdType offset, vtkIdType npts, vtkIdType *pts, vtkPoints *inPts, vtkDataArray *inScalars, vtkFloatArray *newTCoords)
vtkIdType | ComputeOffset (vtkIdType offset, vtkIdType npts)
virtual void | SetInputVectorsSelection (const char *)
## Protected Attributes
float | Width
float | Angle
int | VaryWidth
float | WidthFactor
float | DefaultNormal [3]
int | UseDefaultNormal
int | GenerateTCoords
float | TextureLength
float | Theta
char * | InputVectorsSelection

## Member Typedef Documentation

typedef vtkPolyDataToPolyDataFilter vtkRibbonFilter::Superclass

| Reimplemented from vtkPolyDataToPolyDataFilter. Definition at line 78 of file vtkRibbonFilter.h.

## Constructor & Destructor Documentation

vtkRibbonFilter::vtkRibbonFilter | ( |  | ) | `[protected]`

vtkRibbonFilter::~vtkRibbonFilter | ( |  | ) | `[protected]`

## Member Function Documentation

virtual const char* vtkRibbonFilter::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkPolyDataToPolyDataFilter.

int vtkRibbonFilter::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkPolyDataToPolyDataFilter.

virtual int vtkRibbonFilter::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkPolyDataToPolyDataFilter.

vtkRibbonFilter* vtkRibbonFilter::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkPolyDataToPolyDataFilter.

void vtkRibbonFilter::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkPolyDataToPolyDataFilter.

vtkRibbonFilter* vtkRibbonFilter::New | ( |  | ) | `[static]`

| Construct ribbon so that width is 0.1, the width does not vary with scalar values, and the width factor is 2.0. Reimplemented from vtkObject.

virtual void vtkRibbonFilter::SetWidth | ( | float |  | ) | `[virtual]`

| Set the "half" width of the ribbon. If the width is allowed to vary, this is the minimum width.

virtual float vtkRibbonFilter::GetWidth | ( |  | ) | `[virtual]`

| Set the "half" width of the ribbon. If the width is allowed to vary, this is the minimum width.

virtual void vtkRibbonFilter::SetAngle | ( | float |  | ) | `[virtual]`

| Set the offset angle of the ribbon from the line normal. (The angle is expressed in degrees.)

virtual float vtkRibbonFilter::GetAngle | ( |  | ) | `[virtual]`

| Set the offset angle of the ribbon from the line normal. (The angle is expressed in degrees.)

virtual void vtkRibbonFilter::SetVaryWidth | ( | int |  | ) | `[virtual]`

| Turn on/off the variation of ribbon width with scalar value.

virtual int vtkRibbonFilter::GetVaryWidth | ( |  | ) | `[virtual]`

| Turn on/off the variation of ribbon width with scalar value.

virtual void vtkRibbonFilter::VaryWidthOn | ( |  | ) | `[virtual]`

| Turn on/off the variation of ribbon width with scalar value.

virtual void vtkRibbonFilter::VaryWidthOff | ( |  | ) | `[virtual]`

| Turn on/off the variation of ribbon width with scalar value.

virtual void vtkRibbonFilter::SetWidthFactor | ( | float |  | ) | `[virtual]`

| Set the maximum ribbon width in terms of a multiple of the minimum width.

virtual float vtkRibbonFilter::GetWidthFactor | ( |  | ) | `[virtual]`

| Set the maximum ribbon width in terms of a multiple of the minimum width.

virtual void vtkRibbonFilter::SetDefaultNormal | ( | float | ,
|  | float | ,
|  | float |
| ) | `[virtual]`

| Set the default normal to use if no normals are supplied, and the DefaultNormalOn is set.

virtual void vtkRibbonFilter::SetDefaultNormal | ( | float | [3] | ) | `[virtual]`

| Set the default normal to use if no normals are supplied, and the DefaultNormalOn is set.

virtual float* vtkRibbonFilter::GetDefaultNormal | ( |  | ) | `[virtual]`

| Set the default normal to use if no normals are supplied, and the DefaultNormalOn is set.

virtual void vtkRibbonFilter::GetDefaultNormal | ( | float | data[3] | ) | `[virtual]`

| Set the default normal to use if no normals are supplied, and the DefaultNormalOn is set.

virtual void vtkRibbonFilter::SetUseDefaultNormal | ( | int |  | ) | `[virtual]`

| Set a boolean to control whether to use default normals. DefaultNormalOn is set.

virtual int vtkRibbonFilter::GetUseDefaultNormal | ( |  | ) | `[virtual]`

| Set a boolean to control whether to use default normals. DefaultNormalOn is set.

virtual void vtkRibbonFilter::UseDefaultNormalOn | ( |  | ) | `[virtual]`

| Set a boolean to control whether to use default normals. DefaultNormalOn is set.

virtual void vtkRibbonFilter::UseDefaultNormalOff | ( |  | ) | `[virtual]`

| Set a boolean to control whether to use default normals. DefaultNormalOn is set.

virtual void vtkRibbonFilter::SetGenerateTCoords | ( | int |  | ) | `[virtual]`

| Control whether and how texture coordinates are produced. This is useful for striping the ribbon with time textures, etc.

virtual int vtkRibbonFilter::GetGenerateTCoords | ( |  | ) | `[virtual]`

| Control whether and how texture coordinates are produced. This is useful for striping the ribbon with time textures, etc.

void vtkRibbonFilter::SetGenerateTCoordsToOff | ( |  | ) | `[inline]`

| Control whether and how texture coordinates are produced. This is useful for striping the ribbon with time textures, etc. Definition at line 134 of file vtkRibbonFilter.h. References VTK_TCOORDS_OFF.

void vtkRibbonFilter::SetGenerateTCoordsToNormalizedLength | ( |  | ) | `[inline]`

| Control whether and how texture coordinates are produced. This is useful for striping the ribbon with time textures, etc. Definition at line 136 of file vtkRibbonFilter.h. References VTK_TCOORDS_FROM_NORMALIZED_LENGTH.

void vtkRibbonFilter::SetGenerateTCoordsToUseLength | ( |  | ) | `[inline]`

| Control whether and how texture coordinates are produced. This is useful for striping the ribbon with time textures, etc. Definition at line 138 of file vtkRibbonFilter.h. References VTK_TCOORDS_FROM_LENGTH.

void vtkRibbonFilter::SetGenerateTCoordsToUseScalars | ( |  | ) | `[inline]`

| Control whether and how texture coordinates are produced. This is useful for striping the ribbon with time textures, etc. Definition at line 140 of file vtkRibbonFilter.h. References VTK_TCOORDS_FROM_SCALARS.

const char* vtkRibbonFilter::GetGenerateTCoordsAsString | ( |  | ) |

| Control whether and how texture coordinates are produced. This is useful for striping the ribbon with time textures, etc.

virtual void vtkRibbonFilter::SetTextureLength | ( | float |  | ) | `[virtual]`

| Control the conversion of units during the texture coordinates calculation. The TextureLength indicates what length (whether calculated from scalars or length) is mapped to the [0,1) texture space.

virtual float vtkRibbonFilter::GetTextureLength | ( |  | ) | `[virtual]`

| Control the conversion of units during the texture coordinates calculation. The TextureLength indicates what length (whether calculated from scalars or length) is mapped to the [0,1) texture space.

void vtkRibbonFilter::Execute | ( |  | ) | `[protected, virtual]`

| This method is the old style execute method Reimplemented from vtkSource.

int vtkRibbonFilter::GeneratePoints | ( | vtkIdType | offset,
|  | vtkIdType | npts,
|  | vtkIdType * | pts,
|  | vtkPoints * | inPts,
|  | vtkPoints * | newPts,
|  | vtkPointData * | pd,
|  | vtkPointData * | outPD,
|  | vtkFloatArray * | newNormals,
|  | vtkDataArray * | inScalars,
|  | float | range[2],
|  | vtkDataArray * | inNormals
| ) | `[protected]`

void vtkRibbonFilter::GenerateStrip | ( | vtkIdType | offset,
|  | vtkIdType | npts,
|  | vtkIdType * | pts,
|  | vtkIdType | inCellId,
|  | vtkCellData * | cd,
|  | vtkCellData * | outCD,
|  | vtkCellArray * | newStrips
| ) | `[protected]`

void vtkRibbonFilter::GenerateTextureCoords | ( | vtkIdType | offset,
|  | vtkIdType | npts,
|  | vtkIdType * | pts,
|  | vtkPoints * | inPts,
|  | vtkDataArray * | inScalars,
|  | vtkFloatArray * | newTCoords
| ) | `[protected]`

vtkIdType vtkRibbonFilter::ComputeOffset | ( | vtkIdType | offset,
|  | vtkIdType | npts
| ) | `[protected]`

virtual void vtkRibbonFilter::SetInputVectorsSelection | ( | const char * |  | ) | `[protected, virtual]`

## Member Data Documentation

float vtkRibbonFilter::Width`[protected]`

| Definition at line 159 of file vtkRibbonFilter.h.

float vtkRibbonFilter::Angle`[protected]`

| Definition at line 160 of file vtkRibbonFilter.h.

int vtkRibbonFilter::VaryWidth`[protected]`

| Definition at line 161 of file vtkRibbonFilter.h.

float vtkRibbonFilter::WidthFactor`[protected]`

| Definition at line 162 of file vtkRibbonFilter.h.

float vtkRibbonFilter::DefaultNormal[3]`[protected]`

| Definition at line 163 of file vtkRibbonFilter.h.

int vtkRibbonFilter::UseDefaultNormal`[protected]`

| Definition at line 164 of file vtkRibbonFilter.h.

int vtkRibbonFilter::GenerateTCoords`[protected]`

| Definition at line 165 of file vtkRibbonFilter.h.

float vtkRibbonFilter::TextureLength`[protected]`

| Definition at line 166 of file vtkRibbonFilter.h.

float vtkRibbonFilter::Theta`[protected]`

| Definition at line 183 of file vtkRibbonFilter.h.

char* vtkRibbonFilter::InputVectorsSelection`[protected]`

| Definition at line 187 of file vtkRibbonFilter.h.

The documentation for this class was generated from the following file:

- Graphics/vtkRibbonFilter.h